
#include <stdio.h>    
#include <locale.h>    /* include the declaraiton of setlocale(), 
                          localeconv() etc. */
#include <langinfo.h>  /* include the declarions of nl_langinfo(), and
			  #define for the item names you can request
			  nl_langinfo() to access. */     

main() {
    int i; 		/* for loop index */
    char * current_locale; /* to save locale string returned by
				setlocale() */

                        /* item names for days of the week. */
                        /* To be used to call nl_langinfo() */
    nl_item days[7] = { DAY_1, DAY_2, DAY_3, DAY_4, DAY_5, DAY_6, DAY_7};

    struct lconv *p;      /* pointer returned by localeconv() that points
			     to a lconv structure. */

     
    /**********************************************************************/  
    /* Task 1: do "setlocale(LC_ALL, "")" to set all locale categorie	  */ 
    /*         based on execution time environment variables.             */ 
    /*         You might want to check the return value for errors.       */ 
    /*         setlocale() returns a NULL pointer for error.              */ 
    /**********************************************************************/  

    current_locale = (char *) setlocale(LC_ALL, "");

    /* setlocale returns NULL pointer and stay at "C" locale if error
       occurs. This could happen if the requested locale is not
       installed.  */ 
    if (!current_locale) {
       printf("Cannot operate in the requested locale.\n");
       printf("Continuing in the C locale.\n");
      }
    else
       printf("Current locale sting is: %s\n\n", current_locale);
    

    /**********************************************************************/  
    /* Task 2: Use nl_langinfo to find out the codeset being used,   	  */ 
    /*         and print it out.                                     	  */ 
    /**********************************************************************/  

    printf("The codeset in current locale is:%s\n\n", nl_langinfo(CODESET));


    /**********************************************************************/  
    /* Task 3: Use nl_langinfo to find out the names of the days of the   */ 
    /*         week and print them out. It may be easier for you to use   */ 
    /*         the days[7] array that I set up for you in the beginning of*/ 
    /*         the program.                                               */ 
    /**********************************************************************/  

    for (i=0; i<7; i++)
     {
      printf("day %d of the week is : %12.10s.\n\n ", i+1,
		nl_langinfo(days[i]) );
     }


    /**********************************************************************/  
    /* Task 4: Use localeconv() to find out the currency and decimal point*/ 
    /*         symbol, and print them out.                             	  */ 
    /**********************************************************************/  

    p=localeconv();
    printf("Currency symbol is :  %s\n\n", p->currency_symbol);
    printf("Decimal  point  is :  %s\n\n", p->decimal_point);

}
