#include <X11/Xlib.h>
#include <X11/Xatom.h>
#include <Xm/DrawingA.h>

#include <locale.h>
#include <nl_types.h>
#include <string.h>
#include <signal.h>
#include <stdlib.h> /* needed for MB_CUR_MAX */

/* defines for symbolic set identifiers; to be used with message catalogs */

#define VALUE_SET 1  /* Message catalog set number text widget value strings */
#define DIALOG_SET 2 /* Message catalog set number for dialog strings */
#define PB_SET 3     /* Message catalog set number for pushbutton labels */
#define HELP_SET 4   /* Message catalog set number for help box dialog */
#define TRANS_SET 5  /* Message catalog set number for translations */
#define ERROR_SET 6  /* Message catalog set number for error messages */

#define MAXLINESIZE	256
#define MAXLINES	100
#define TEXT_MAX_INSERT_SIZE  80

typedef struct {
  XPoint	location;
  char		text[MAXLINESIZE];
  wchar_t	wc_text[MAXLINESIZE];
  int		num_chars; /* number of characters in the string. */
} MyLineRec, *MyLineRecPtr;

typedef struct {
  int		line_height;
  int		ascent;
  int		descent;
  Widget	widget;
  MyLineRec	lines[MAXLINES];
  int		num_lines;
  int		active_line;   /* line where current I/O is happening */
  XmFontList	fontlist;
  XFontSet	fontset;
  XFontStruct	*font;
} DrawData, *DrawDataPtr;

XtAppContext  app_context;
