
/*****************************************************************/
/* This program prints the current time using the format of      */
/* of the current locale.                                        */
/*****************************************************************/

#include <stdio.h>
#include <locale.h>
#include <langinfo.h>
#include <wchar.h>
#include <time.h>

main() {
    wchar_t wctimebuf[BUFSIZ];
    char mbtimebuf[BUFSIZ];

    time_t clock;
    struct tm *tmptr;

    clock = time ( (time_t*) NULL); /* Get the time in seconds since 00:00:00
                                       UTC, 1 January 1970. */
    tmptr = localtime(&clock);      /* Convert the time in seconds into a
                                       "tm" structure. */

    (void) setlocale(LC_ALL, "");
     
    /* Call nl_langinfo(D_T_FMT) to retrieve locale-specific time format,
       and call strftime() to format the time in "tm" structure according
       to the locale-specific format. */
    strftime(
	     mbtimebuf,
	     BUFSIZ,
	     nl_langinfo(D_T_FMT),
   	     tmptr);
    printf("%s\n", mbtimebuf);
	

    /* Call nl_langinfo(D_T_FMT) to retrieve locale-specific time format,
       and call wcsftime() to format the time in "tm" structure according
       to the locale-specific format. */
    wcsftime(
	     wctimebuf,
             BUFSIZ, 
	     nl_langinfo(D_T_FMT),
	     tmptr);
    printf("%S\n", wctimebuf);

    }

